diff -Nrc2 fontutils-0.5/bzrto/pstype1.c fontutils-0.6/bzrto/pstype1.c
*** fontutils-0.5/bzrto/pstype1.c	Mon Aug 31 15:43:04 1992
--- fontutils-0.6/bzrto/pstype1.c	Mon Oct 19 17:15:36 1992
***************
*** 23,29 ****
  #include "bzr.h"
  #include "char.h"
  #include "hexify.h"
  #include "spline.h"
- #include "tfm.h"
  #include "varstring.h"
  #include "vector.h"
--- 23,29 ----
  #include "bzr.h"
  #include "char.h"
+ #include "encoding.h"
  #include "hexify.h"
  #include "spline.h"
  #include "varstring.h"
  #include "vector.h"
***************
*** 44,53 ****
  static real em_factor;
  
! /* The interword space from the TFM file, in points.  */
! static real tfm_space;
  
! /* The UniqueID from the font info, or zero.  */
! static unsigned unique_id;
  
  
  /* This should be used for outputting a string S on a line by itself.  */
--- 44,67 ----
  static real em_factor;
  
! /* The interword space, in points.  */
! static real interword_space;
  
! /* Whether or not a particular character has been written.  We depend on
!    this being initialized to false by virtue of its storage class.  */
! static boolean char_output_p[ENCODING_VECTOR_SIZE];
! 
! /* For each character code, tells the corresponding subroutine number;
!    assigned by `output_subr_start'.  */
! static unsigned subr_number[MAX_CHARCODE + 1];
  
+ /* As we read a character, we encode each command in the Type 1 scheme
+    and stick the result into a buffer.  (Because we need to output the
+    length of the entire charstring before we output the charstring
+    itself, we can't output as we go.)  */
+ static variable_string charstring_buffer;
+ 
+ /* Before encrypting, fill this and prepend onto above.  */
+ static variable_string pre_charstring_buffer;
+ 
  
  /* This should be used for outputting a string S on a line by itself.  */
***************
*** 64,99 ****
  #define OUT4(s, e1, e2, e3, e4)						\
    do { fprintf (ps_file, s, e1, e2, e3, e4); } while (0)
! 
  /* Type 1 opcodes.  */
  typedef unsigned char type1_opcode;
  
! #define T1_CALLSUBR		10
! #define T1_CLOSEPATH		9
! #define T1_ENDCHAR		14
! #define T1_HLINETO		6
! #define T1_HMOVETO		22
! #define T1_HSBW			13
! #define T1_HVCURVETO		31
! #define T1_RETURN		11
! #define T1_RLINETO		5
! #define T1_RMOVETO		21
! #define T1_RRCURVETO		8
  #define T1_VHCURVETO	30
! #define T1_VLINETO	7
! #define T1_VMOVETO	4
! 
! #define PUT_END "|"
! #define DEF_END "|-"
! 
! /* The first three positions in the Subrs array are reserved.  */
! #define SUBRS_OFFSET 4
! #define CHARCODE_TO_SUBRS_INDEX(c) ((c) + SUBRS_OFFSET)
  
! #define OUT_CHAR_SUBR(c) 						\
!  do {									\
!       absolute_cs_number (CHARCODE_TO_SUBRS_INDEX (c), &charstring_buffer);\
!       cs_byte (T1_CALLSUBR, &charstring_buffer);			\
!     } while (0)
  
  static void begin_char (string);
  static void end_char (real, real);
--- 78,105 ----
  #define OUT4(s, e1, e2, e3, e4)						\
    do { fprintf (ps_file, s, e1, e2, e3, e4); } while (0)
! 
! 
  /* Type 1 opcodes.  */
  typedef unsigned char type1_opcode;
  
! #define T1_CALLSUBR	10
! #define T1_CLOSEPATH	 9
! #define T1_ENDCHAR	14
! #define T1_HLINETO	 6
! #define T1_HMOVETO	22
! #define T1_HSBW		13
! #define T1_HVCURVETO	31
! #define T1_RETURN	11
! #define T1_RLINETO	 5
! #define T1_RMOVETO	21
! #define T1_RRCURVETO	 8
  #define T1_VHCURVETO	30
! #define T1_VLINETO	 7
! #define T1_VMOVETO	 4
  
! #define READONLY_PUT "|"
! #define READONLY_DEF "|-"
  
+ static void absolute_cs_number (int, variable_string *);
  static void begin_char (string);
  static void end_char (real, real);
***************
*** 101,108 ****
  static variable_string cs_encrypt (variable_string);
  static void cs_number (real, variable_string *);
- static void absolute_cs_number (int, variable_string *);
  static void init_charstring_buffers (void);
  static void out_curveto (real_coordinate_type *, spline_type);
  static void out_lineto (real_coordinate_type *, real_coordinate_type);
  static void out_moveto (real_coordinate_type *, real_coordinate_type);
  static void out_point (real_coordinate_type *, real_coordinate_type);
--- 107,116 ----
  static variable_string cs_encrypt (variable_string);
  static void cs_number (real, variable_string *);
  static void init_charstring_buffers (void);
+ static void out_bb_char
+   (real_bounding_box_type *, real_coordinate_type *, bzr_char_type);
  static void out_curveto (real_coordinate_type *, spline_type);
  static void out_lineto (real_coordinate_type *, real_coordinate_type);
+ static void out_move (real_coordinate_type *, real, real, boolean);
  static void out_moveto (real_coordinate_type *, real_coordinate_type);
  static void out_point (real_coordinate_type *, real_coordinate_type);
***************
*** 109,144 ****
  static void out_relative_cmd (real_coordinate_type *, real_coordinate_type,
                                type1_opcode, type1_opcode, type1_opcode);
  static void output_charstring_buffers (string);
! static void output_private_dict_1 (void);
  static void output_private_dict_2 (void);
  static int points_to_adobes (real);
  
! /* As we read a character, we encode each command in the Type 1 scheme
!    and stick the result into a buffer.  (Because we need to output the
!    length of the entire charstring before we output the charstring
!    itself, we can't output as we go.)  */
! static variable_string charstring_buffer;
  
! /* Before encrypting, fill this and prepend onto above.  */
! static variable_string pre_charstring_buffer;
  
! /* This should be called before the others in this file.  It opens the
!    output file `OUTPUT_NAME.gsf', writes some preliminary boilerplate, the
!    font bounding box, and sets up to write the characters.  */
  
  void
! pstype1_start_output (string font_name, string output_name,
! 		      bzr_preamble_type pre, bzr_postamble_type post, 
!                       string ps_fontname, tfm_global_info_type tfm_info)
! {
!   /* Find general information about the font.  Pass in the filename
!      we were given.  */
!   ps_font_info_type ps_info = ps_init (font_name, ps_fontname, tfm_info);
! 
!   /* Remember the natural interword space, so we can output it later, if
!      necessary.  Ditto for the UniqueID.  */
!   tfm_space = TFM_SAFE_FONTDIMEN (tfm_info, TFM_SPACE_PARAMETER, 0);
!   unique_id = ps_info.unique_id;
  
    /* If a Type 3 font is eexec-encrypted and in ASCII, its extension
       should be `pfa'.  If they are eexec-encrypted and binary, its
--- 117,158 ----
  static void out_relative_cmd (real_coordinate_type *, real_coordinate_type,
                                type1_opcode, type1_opcode, type1_opcode);
+ static void output_bzr_body (bzr_char_type);
+ static real_bounding_box_type output_ccc_body (ccc_type, char_type **);
+ static void output_char_finish (real, real, charcode_type);
+ static boolean output_char_start (charcode_type);
  static void output_charstring_buffers (string);
! static void output_private_dict_1 (unsigned);
  static void output_private_dict_2 (void);
+ static void output_subr_end (void);
+ static void output_subr_start (charcode_type);
  static int points_to_adobes (real);
  
! /* Convert N, a number in printer's points, to the 1000-unit/em
!    coordinate system the Type 1 format requires.  (We call these units
!    ``adobes''.)  We've already computed the scaling factor `em_factor'
!    for this, since it depends only on the design size of the font.  */
  
! static int
! points_to_adobes (real n)
! {
!   int n_in_adobes = ROUND (n * em_factor);
!   
!   return n_in_adobes;
! }
  
! /* This routine should be called before the others in this file.  It
!    opens the output file `OUTPUT_NAME.gsf', writes some preliminary
!    boilerplate, the font bounding box, and sets up to write the
!    characters.  */
  
  void
! pstype1_start_output (string output_name,
! 		      bzr_preamble_type pre, bzr_postamble_type post)
! {
!   ps_font_info_type ps_info = ps_set_font_info ();
  
+   /* Remember the natural interword space, so we can output it later.  */
+   interword_space = ps_info.interword_space;
+ 
    /* If a Type 3 font is eexec-encrypted and in ASCII, its extension
       should be `pfa'.  If they are eexec-encrypted and binary, its
***************
*** 159,163 ****
       this font's size.  */
    OUT_LINE ("/FontMatrix [0.001 0 0 0.001 0 0] readonly def"); 
!   em_factor = 1000.0 / TFM_DESIGN_SIZE (tfm_info);
    
    /* Some interpreters refuse to handle a normal array,
--- 173,177 ----
       this font's size.  */
    OUT_LINE ("/FontMatrix [0.001 0 0 0.001 0 0] readonly def"); 
!   em_factor = 1000.0 / BZR_DESIGN_SIZE (pre);
    
    /* Some interpreters refuse to handle a normal array,
***************
*** 172,204 ****
       we've read all the characters, so we can guess good values.  I hope
       this doesn't break any interpreters, but it probably will.  */
!   output_private_dict_1 ();
! 
!   /* Start the character subroutine definitions.  */
    
!   /* Define Subrs as part of Private; also, we must make the procedures
!      in the Private dictionary visible because the CharStrings definitions
!      will use them.  */
    OUT_LINE ("Private begin");
!   OUT1 ("/Subrs %d array \n", MAX_CHARCODE + 1 + SUBRS_OFFSET);
  }
! 
  void
! pstype1_intermediate_output ()
  {
!   /* End the subroutine definitions and start the character definitions.
!      Aside from the characters in the input font, we always output
!      characters `.notdef' and `space'.  */
!      
!   OUT_LINE (DEF_END);
!   OUT1 ("/CharStrings %d dict begin\n", MAX_CHARCODE + 1);
  
!   begin_char (".notdef");
!   end_char (0, 0);
  }
  
! /* Output the character C as a subroutine.  */
  
  void
! pstype1_output_char_subr (bzr_char_type c)
  {
    unsigned this_list;
--- 186,372 ----
       we've read all the characters, so we can guess good values.  I hope
       this doesn't break any interpreters, but it probably will.  */
!   output_private_dict_1 (ps_info.unique_id);
! }
! 
! /* Start the character subroutine definitions.  We need to make the
!    procedures in `Private' visible because the charstring definitions
!    use them -- i.e., the `-|', `-|', and `|' routines.  */
    
! void
! pstype1_start_subrs (unsigned subr_count)
! {
    OUT_LINE ("Private begin");
!   OUT1 ("/Subrs %d array \n", subr_count);
  }
! 
! 
! /* Output the BZR character C as a subroutine.  */
! 
  void
! pstype1_output_bzr_subr (bzr_char_type c)
  {
!   output_subr_start (CHARCODE (c));
!   output_bzr_body (c);
!   output_subr_end ();
! }
  
! 
! /* And the same, for the CCC character C.  */
! 
! void
! pstype1_output_ccc_subr (ccc_type c, charcode_type code, char_type *subrs[])
! {
!   output_subr_start (code);
!   output_ccc_body (c, subrs);
!   output_subr_end ();
! }
! 
! 
! /* Output a call to the subroutine corresponding to the character code
!    CODE.  */
! 
! #define OUT_CHAR_SUBR(code) 						\
!  do {									\
!    absolute_cs_number (subr_number[code], &charstring_buffer);		\
!    cs_byte (T1_CALLSUBR, &charstring_buffer);				\
!  } while (0)
! 
! 
! /* Output the common beginning of a subroutine.  We don't check if CODE
!    is in the encoding, since a character might well be used as a
!    subroutine but not be encoded.  */
! 
! static void
! output_subr_start (charcode_type code)
! {
!   static unsigned current_subr_number = 0;
!   
!   subr_number[code] = current_subr_number;
!   OUT1 ("dup %d ", current_subr_number++);
!   init_charstring_buffers ();
! }
! 
! 
! /* And the common ending.  */
! 
! static void
! output_subr_end ()
! {
!   cs_byte (T1_RETURN, &charstring_buffer);
!   output_charstring_buffers (READONLY_PUT);
  }
  
! /* End the subroutine definitions and start the character definitions.
!    Aside from the characters in the input font, we always output
!    the two characters `.notdef' and `space' (this happens in
!    `pstype1_finish_output).  */
!      
! void
! pstype1_start_chars (unsigned char_count)
! {
!   OUT_LINE (READONLY_DEF " % Subrs");
!   OUT1 ("/CharStrings %d dict begin\n", char_count + 2);
! }
! 
! 
! /* Output the BZR character C; if it is defined in SUBRS, just output a
!    call to the already-defined subroutine.  */
! 
! void
! pstype1_output_bzr_char (bzr_char_type c, char_type *subrs[])
! {
!   unsigned code = CHARCODE (c);
!   
!   if (output_char_start (code))
!     {
!       if (subrs[code])
!         OUT_CHAR_SUBR (code);
!       else
!         output_bzr_body (c);
!       
!       output_char_finish (CHAR_LSB (c), CHAR_SET_WIDTH (c), code);
!     }
! }
! 
  
+ /* Output the CCC character C with character code CODE, and using the
+    character definitions in SUBRS.  */
+ 
  void
! pstype1_output_ccc_char (ccc_type c, charcode_type code, char_type *subrs[])
! {
!   if (output_char_start (code))
!     {
!       if (subrs[code])
!         WARNING ("Sorry, CCC characters can't be subroutines yet");
!       else
!         {
!           real_bounding_box_type bb = output_ccc_body (c, subrs);
!           output_char_finish (MIN_COL (bb), MAX_COL (bb), code);
!         }
!     }
! }
! 
! 
! /* Common beginning for characters.  */
! 
! static boolean
! output_char_start (charcode_type code)
! {
!   string charname = ps_encoding_name (code);
!   boolean ok = !STREQ (charname, ".notdef");
!   
!   if (ok)
!     begin_char (charname);
!   
!   return ok;
! }
! 
! 
! /* Begin a character definition, i.e., a definition in the CharStrings
!    dictionary.  We are given the character name, the left sidebearing,
!    and the set width.  The latter two are in printer's points.  We
!    always output an `hsbw' command -- our characters do not have y
!    sidebearings.  */
! 
! static void
! begin_char (string name)
! {
!   OUT1 ("/%s\t", name);
! 
!   /* We cannot just output the bytes of the charstring as we go, because
!      we need to output the length of the charstring before the
!      charstring itself, so we can use readhexstring in the PostScript.  */
!   init_charstring_buffers ();
! }
! 
! 
! /* Common ending.  */
! 
! static void
! output_char_finish (real lsb, real set_width, charcode_type code)
! {
!   end_char (lsb, set_width);
!   char_output_p[code] = true;
! }
! 
! 
! /* End a character definition with the `endchar' command.  */
! 
! static void
! end_char (real lsb, real set_width)
! {
!   cs_number (lsb, &pre_charstring_buffer);
!   cs_number (set_width, &pre_charstring_buffer);
!   cs_byte (T1_HSBW, &pre_charstring_buffer);
! 
!   cs_byte (T1_ENDCHAR, &charstring_buffer);
!   output_charstring_buffers (READONLY_DEF);
! }
! 
! /* Output the splines in C.  */
! 
! static void
! output_bzr_body (bzr_char_type c)
  {
    unsigned this_list;
***************
*** 206,218 ****
    real_coordinate_type start = { 0.0, 0.0 };
    real_coordinate_type current = start;
-   charcode_type code = CHARCODE (c);
-   string charname = ps_encoding_name (code);
-   
-   if (STREQ (charname, ".notdef"))
-     return;
-     
-   /* Start the definition.  */
-   OUT1 ("dup %d ", CHARCODE_TO_SUBRS_INDEX (code));
-   init_charstring_buffers ();
  
    /* Go through the list of splines, outputting the
--- 374,377 ----
***************
*** 242,397 ****
        cs_byte (T1_CLOSEPATH, &charstring_buffer);
      }
-   out_moveto (&current, start);
-   cs_byte (T1_RETURN, &charstring_buffer);
-   output_charstring_buffers (PUT_END);
- }
- 
- /* Output a character which only uses one subroutine.  */
- 
- void
- pstype1_output_bzr_char (bzr_char_type c)
- {
-   charcode_type code = CHARCODE (c);
-   string charname = ps_encoding_name (code);
  
!   begin_char (charname);
!   OUT_CHAR_SUBR (code);
!   end_char (CHAR_LSB (c), CHAR_SET_WIDTH (c));
!   ps_char_output_p[CHARCODE (c)] = true;
  }
- 
- /* Macros for pstype1_output_ccc_char: assume `cp' and `bb' are defined.  */ 
- 
- /* Moves.  */
  
- #define OUT_MOVE(h, v, a)						\
-   do									\
-     {									\
-       real_coordinate_type save_cp = cp;				\
-       real_coordinate_type rel_p = (real_coordinate_type){h, v};	\
-       out_moveto (&cp, Padd (cp, rel_p));				\
-       cp = save_cp;							\
-     }									\
-   while (0)
-   
- #define OUT_HMOVE(h, a) OUT_MOVE (h, 0.0, a)
- #define OUT_VMOVE(v, a) OUT_MOVE (0.0, v, a)
- 
- /* Output a(n absolute, if ABSOLUTE is true) move to relative (H, V),
-    updating the bounding box and the current point.  */
-    
- #define OUTPUT_MOVE(h, v, absolute)					\
-   do									\
-     {									\
-       OUT_HMOVE (h, absolute);						\
-       UPDATE_BB_MOVE (h, v);						\
-       UPDATE_CP_MOVE (h, v);						\
-     }									\
-   while (0);
- 
- 
- /* Update bounding box `bb' using BC's bounding box relative to `cp'.  */
- 
- #define UPDATE_BB_CHAR(bc)						\
-   do 									\
-     {									\
-       update_real_bounding_box (&(bb), 					\
-            (real_coordinate_type) {cp.x + BZR_CHAR_MIN_COL (bc),	\
-                                    cp.y + BZR_CHAR_MIN_ROW (bc)});	\
- 									\
-       update_real_bounding_box (&(bb), 					\
-            (real_coordinate_type) {cp.x + BZR_CHAR_MAX_COL (bc),	\
-                                    cp.y + BZR_CHAR_MAX_ROW (bc)});	\
-     }									\
-   while (0);
- 
- 
- /* Update bounding box `bb' according to a move H, V relative to `cp'.  */
- 
- #define UPDATE_BB_MOVE(h, v) 						\
-   update_real_bounding_box (&(bb), 					\
- 		            (real_coordinate_type) {cp.x + h, cp.y + v});
- 
- 
- /* Update the current point according to a move H, V.  */
- 
- #define UPDATE_CP_MOVE(h, v) 						\
-   cp = Padd (cp, ((real_coordinate_type){(h), (v)}))
- 
- 
- /* Output a character with charcode C, updating the bounding box for it.  */
- #define OUTPUT_BB_CHAR(bc, c)						\
-   do									\
-     {									\
-       OUT_CHAR_SUBR (c);						\
-       UPDATE_BB_CHAR (bc);						\
-       OUT_HMOVE (BZR_CHAR_BB_WIDTH (bc), false);			\
-       UPDATE_CP_MOVE (BZR_CHAR_BB_WIDTH (bc), 0);			\
-     }									\
-   while (0);
  
  
! /* Output the composite character C.  */
  
! void
! pstype1_output_ccc_char (ccc_type ccc_char, char_type **chars,
!                          charcode_type ccc_code, real bzr_designsize)
  {
-   real ccc_char_lsb;
    unsigned this_cmd;
!   real_coordinate_type cp = (real_coordinate_type) { 0.0, 0.0 };
    real_bounding_box_type bb
      = (real_bounding_box_type) { FLT_MAX, FLT_MIN, FLT_MAX, FLT_MIN };
-   string charname = ps_encoding_name (ccc_code);
  
-   begin_char (charname);
- 
    for (this_cmd = 0; this_cmd < LIST_SIZE (ccc_char); this_cmd++)
      { 
-       real move;
-       bzr_char_type *bzr_char;
-       charcode_type bzr_code;
        ccc_cmd_type cmd = *(ccc_cmd_type *) LIST_ELT (ccc_char, this_cmd);
-       int op_code = CCC_OPCODE (cmd);
        
!       switch (op_code)
          {
          case TR_SETCHAR:
!           bzr_code = CCC_CHARCODE (cmd);
!           bzr_char = CHAR_BZR_INFO (*(chars[bzr_code]));
!           ccc_char_lsb = CHAR_LSB (*bzr_char);
!           OUTPUT_MOVE ((real) CHAR_LSB (*bzr_char), 0, false);
!           OUTPUT_BB_CHAR (*bzr_char, bzr_code);
!           OUTPUT_MOVE ((real) CHAR_RSB (*bzr_char), 0, false);
            break;
  
          case TR_SETCHARBB:
!           bzr_code = CCC_CHARCODE (cmd);
!           bzr_char = CHAR_BZR_INFO (*(chars[bzr_code]));
!           ccc_char_lsb = 0;
!           OUTPUT_BB_CHAR (*bzr_char, bzr_code);
            break;
  
          case TR_HMOVE:
!           move = CCC_DIMEN_AMOUNT (cmd);
!           OUT_HMOVE (move, CCC_DIMEN_ABSOLUTE (cmd));
!           UPDATE_CP_MOVE (move, 0);
            break;
  
          case TR_VMOVE:
!           move = CCC_DIMEN_AMOUNT (cmd);
!           OUT_VMOVE (move, CCC_DIMEN_ABSOLUTE (cmd));
!           UPDATE_CP_MOVE (0, move);
            break;
  
          default:
!           FATAL2 ("bad command %d in CCC character %d", op_code, ccc_code);
!           break;
  	}
      }
!   end_char (ccc_char_lsb, BB_WIDTH (bb));
!   ps_char_output_p[ccc_code] = true;
  
!   char_make_tfm (chars, ccc_code, bb);
  }
  
--- 401,524 ----
        cs_byte (T1_CLOSEPATH, &charstring_buffer);
      }
  
!   /* If we're outputting a subroutine, we want to wind up back at the
!      origin, I guess.  */
!   out_moveto (&current, start);
  }
  
  
+ /* Output the composite character C, with all subroutines defined in SUBRS.  */
  
! #define OUT_HMOVE(h, a) out_move (&current, h, 0.0, a)
! #define OUT_VMOVE(v, a) out_move (&current, 0.0, v, a)
  
! static real_bounding_box_type
! output_ccc_body (ccc_type ccc_char, char_type **subrs)
  {
    unsigned this_cmd;
!   real_coordinate_type current = (real_coordinate_type) { 0.0, 0.0 };
    real_bounding_box_type bb
      = (real_bounding_box_type) { FLT_MAX, FLT_MIN, FLT_MAX, FLT_MIN };
  
    for (this_cmd = 0; this_cmd < LIST_SIZE (ccc_char); this_cmd++)
      { 
        ccc_cmd_type cmd = *(ccc_cmd_type *) LIST_ELT (ccc_char, this_cmd);
        
!       switch (CCC_OPCODE (cmd))
          {
          case TR_SETCHAR:
!           {
!             char_type subr = *subrs[CCC_CHARCODE (cmd)];
! 
!             if (CHAR_CLASS (subr) == bzr_char_class)
!               {
!                 bzr_char_type bzr_char = *CHAR_BZR (subr);
!                 
!                 update_real_bounding_box (&bb, current);
!                 OUT_HMOVE (CHAR_LSB (bzr_char), false);
! 
!                 out_bb_char (&bb, &current, bzr_char);
! 
!                 OUT_HMOVE (CHAR_RSB (bzr_char), false);
!                 update_real_bounding_box (&bb, current);
!               }
!             else
!               /* We haven't implemented this yet since it doesn't seem
!                  all that necessary at the moment, and it would require
!                  figuring out a bounding box and possibly side bearings
!                  for CCC character -- certainly not impossible, but not
!                  trivial, either.  */
!               WARNING ("Sorry, I can't `setchar' a CCC char yet");
!           }
            break;
  
          case TR_SETCHARBB:
!           {
!             char_type subr = *subrs[CCC_CHARCODE (cmd)];
! 
!             if (CHAR_CLASS (subr) == bzr_char_class)
!               out_bb_char (&bb, &current, *CHAR_BZR (subr));
!             else
!               WARNING ("Sorry, I can't `setcharbb' a CCC char yet");
!           }
            break;
  
          case TR_HMOVE:
!           OUT_HMOVE (CCC_DIMEN_AMOUNT (cmd), CCC_DIMEN_ABSOLUTE (cmd));
            break;
  
          case TR_VMOVE:
!           OUT_VMOVE (CCC_DIMEN_AMOUNT (cmd), CCC_DIMEN_ABSOLUTE (cmd));
            break;
  
          default:
!           FATAL1 ("Bad command %d in CCC character", CCC_OPCODE (cmd));
  	}
      }
!   
!   return bb;
! }
! /* Move by H horizontally and V vertically.  If ABSOLUTE is true, the
!    amount moved is supposed to be independent of the character size, but
!    we don't know how to implement that yet.  Update CURRENT.  */
! 
! static void
! out_move (real_coordinate_type *current, real h, real v, boolean absolute)
! {
!   real_coordinate_type new
!     = (real_coordinate_type) { current->x + h, current->y + v};
! 
!   if (absolute)
!     WARNING2 ("Move [by (%.2f,%.2f)] in absolute units unimplemented", h, v);
! 
!   out_moveto (current, new);
!   *current = new;
! }
! 
  
! /* Output the character shape in BZR_CHAR, sans side bearings.  Update
!    CURRENT by the width of the shape, and update BB by the points before
!    and after the character.  We take into account the height of the
!    character when updating BB, even though we don't translate the
!    current point up there.  */
! 
! #define VOFFSET_POINT(voffset) \
!   ((real_coordinate_type) { current->x, current->y + (voffset) })
! 
! static void
! out_bb_char (real_bounding_box_type *bb, real_coordinate_type *current,
!              bzr_char_type bzr_char)
! {
!   /* Update BB with the current point.  */
!   update_real_bounding_box (bb, VOFFSET_POINT (CHAR_MIN_ROW (bzr_char)));
! 
!   /* Output the call to the character.  */
!   OUT_CHAR_SUBR (CHARCODE (bzr_char));
!   
!   /* Move by the width of the shape.  */
!   out_move (current, BB_WIDTH (CHAR_BB (bzr_char)), 0, false);
! 
!   /* Update the BB again with the new current point.  */
!   update_real_bounding_box (bb, VOFFSET_POINT (CHAR_MAX_ROW (bzr_char)));
  }
  
***************
*** 494,498 ****
      }
    
!   /* Fall back.  */
    else
      {
--- 621,625 ----
      }
    
!   /* Fall back to general case.  */
    else
      {
***************
*** 503,550 ****
      }
  }
- 
- /* Begin a character definition, i.e., a definition in the CharStrings
-    dictionary.  We are given the character name, the left sidebearing,
-    and the set width.  The latter two are in printer's points.  We
-    always output an `hsbw' command -- our characters do not have y
-    sidebearings.  */
- 
- static void
- begin_char (string name)
- {
-   OUT1 ("/%s ", name);
- 
-   /* We cannot just output the bytes of the charstring as we go, because
-      we need to output the length of the charstring before the
-      charstring itself, so we can use readhexstring in the PostScript.  */
-   init_charstring_buffers ();
- }
- 
- 
- /* End a character definition with the `endchar' command.  */
- 
- static void
- end_char (real lsb, real set_width)
- {
-   cs_number (lsb, &pre_charstring_buffer);
-   cs_number (set_width, &pre_charstring_buffer);
-   cs_byte (T1_HSBW, &pre_charstring_buffer);
- 
-   cs_byte (T1_ENDCHAR, &charstring_buffer);
-   output_charstring_buffers (DEF_END);
- }
- 
- /* Convert N, a number in printer's points, to the 1000-unit/em coordinate
-    system the Type 1 format requires.  (We call these units ``adobes''.)
-    We've already computed the scaling factor for this, since it depends
-    only on the design size of the font.  */
- 
- static int
- points_to_adobes (real n)
- {
-   int n_in_adobes = ROUND (n * em_factor);
-   
-   return n_in_adobes;
- }
  
  /* Charstring operations.  */
--- 630,633 ----
***************
*** 577,581 ****
    absolute_cs_number (n_in_adobes, buffer);
  }
!   
  static void
  absolute_cs_number (int n, variable_string *buffer)
--- 660,667 ----
    absolute_cs_number (n_in_adobes, buffer);
  }
! 
! 
! /* See section 6.2 of the book Adobe Type 1 Font Format.  */
! 
  static void
  absolute_cs_number (int n, variable_string *buffer)
***************
*** 633,639 ****
  /* Output what we've collected in `pre_charstring_buffer' and
     `charstring_buffer'.  Because Type 1 BuildChar is only required to
!    handle encrypted charstrings, we must encrypt our encoded charstring.
!    END is xx.
!    */
  
  static void
--- 719,723 ----
  /* Output what we've collected in `pre_charstring_buffer' and
     `charstring_buffer'.  Because Type 1 BuildChar is only required to
!    handle encrypted charstrings, we must encrypt our encoded charstring.  */
  
  static void
***************
*** 670,684 ****
    /* If the space character hasn't been output, do so (even if it won't
       be encoded).  */
!   if (space_encoding == -1 || !ps_char_output_p[space_encoding])
      {
        begin_char ("space");
!       end_char (0, tfm_space);
        if (space_encoding != -1)
!         ps_char_output_p[ps_encoding_number ("space")] = true;
      }
  
    /* Pop the Private and CharStrings dictionaries from the dictionary
       stack, then define the latter in the main font dict.  */
!   OUT_LINE ("currentdict end readonly");
    OUT_LINE ("end % Private");
    OUT_LINE ("def % CharStrings");
--- 754,772 ----
    /* If the space character hasn't been output, do so (even if it won't
       be encoded).  */
!   if (space_encoding == -1 || !char_output_p[space_encoding])
      {
        begin_char ("space");
!       end_char (0, interword_space);
        if (space_encoding != -1)
!         char_output_p[space_encoding] = true;
      }
  
+   /* Always output `.notdef'.  */
+   begin_char (".notdef");
+   end_char (0, 0);
+ 
    /* Pop the Private and CharStrings dictionaries from the dictionary
       stack, then define the latter in the main font dict.  */
!   OUT_LINE ("currentdict end readonly % CharStrings");
    OUT_LINE ("end % Private");
    OUT_LINE ("def % CharStrings");
***************
*** 685,689 ****
  
    /* Two more elements go in the font dictionary.  */
!   ps_output_encoding (ps_file);
    output_private_dict_2 ();
  
--- 773,777 ----
  
    /* Two more elements go in the font dictionary.  */
!   ps_output_encoding (ps_file, char_output_p);
    output_private_dict_2 ();
  
***************
*** 693,698 ****
    xfclose (ps_file, ps_filename);
  }
! 
! 
  /* The first part of the Private dictionary defines things that are
     independent of the character definitions.  */
--- 781,785 ----
    xfclose (ps_file, ps_filename);
  }
! 
  /* The first part of the Private dictionary defines things that are
     independent of the character definitions.  */
***************
*** 699,710 ****
  
  static void
! output_private_dict_1 ()
  {
!   OUT_LINE ("/Private 8 dict begin");
    OUT_LINE ("  /MinFeature {16 16} def");
    OUT_LINE ("  /password 5839 def");
  
!   /* According to the spec, the only reason to set lenIV to 4 is to be
!      compatible with the interpreter in the original LaserWriter.  We
       don't care about that, so we may as well reduce the number of bytes
       wasted on encryption.  */
--- 786,797 ----
  
  static void
! output_private_dict_1 (unsigned unique_id)
  {
!   OUT_LINE ("/Private 9 dict begin");
    OUT_LINE ("  /MinFeature {16 16} def");
    OUT_LINE ("  /password 5839 def");
  
!   /* According to the spec, the only reason to keep `lenIV' at 4 is to
!      be compatible with the interpreter in the original LaserWriter.  We
       don't care about that, so we may as well reduce the number of bytes
       wasted on encryption.  */
***************
*** 712,716 ****
  
    if (unique_id)
!     OUT1   ("  /UniqueID %d def\n", unique_id);
  
    /* Here is how a character or a subroutine will get defined.  We
--- 799,803 ----
  
    if (unique_id)
!     OUT1 ("  /UniqueID %d def\n", unique_id);
  
    /* Here is how a character or a subroutine will get defined.  We
***************
*** 722,730 ****
    OUT_LINE ("  /-| {string currentfile exch readhexstring pop} readonly def");
  
!   /* Once we have the string, we have to define the character.  */
    OUT_LINE ("  /|- {readonly def} readonly def");
  
!   /* Once we have the string, we have to define the subroutine.  */
!   OUT_LINE ("  /| {readonly put} readonly def");
    
    /* End defining the private dictionary.  */
--- 809,817 ----
    OUT_LINE ("  /-| {string currentfile exch readhexstring pop} readonly def");
  
!   /* Once we have the string, this procedure defines the character.  */
    OUT_LINE ("  /|- {readonly def} readonly def");
  
!   /* Likewise, for subroutines.  */
!   OUT_LINE ("  /|  {readonly put} readonly def");
    
    /* End defining the private dictionary.  */
***************
*** 735,739 ****
  /* The second part of the Private dictionary defines the hinting
     information, which we know only after we've seen the characters.  Or
!    at least we will know it after we understand how to output hints.  */
  
  static void
--- 822,826 ----
  /* The second part of the Private dictionary defines the hinting
     information, which we know only after we've seen the characters.  Or
!    at least we might know it after we understand how to output hints.  */
  
  static void
